import numpy as np

D = np.loadtxt( "datos.txt" )
print( D.shape )

#
np.random.seed(1)

eta = 1.0

#  Para cada neurona es un vectos [w1, w2, 1]^T
# P1 = np.random.rand( 3, 2 ) - 0.5   # Dos neuronas
# P2 = np.random.rand( 3, 1 ) - 0.5   # Una neurona en la capa oculta

P1 = np.array( [ [ 4.792, 4.792 ],
                 [ 4.486, 4.486 ],
                 [ 4.590,-4.486 ] ] )

P2 = np.array( [ [ -9.180 ],
                 [  9.178 ],
                 [  4.420 ] ] )

#P1 = np.array( [[ -2.31964917,  -2.72971784],
#                [ -7.14865779,  -7.26299787],
#                [224.01778789, 215.89579591]] )
#P2 = np.array( [[-42.27801657],
#                [-41.50402389],
#                [-44.01130694]] )


# Para guardar 
Z1 = np.zeros( (1,2) )
A1 = np.zeros( (1,3) )
Delta1 = np.zeros( (2,1) )

Z2 = np.zeros( (1,1) )
A2 = np.zeros( (1,1) )
Delta2 = np.zeros( (1,1) )

def sigmoide( x ) :
	return 1.0/(1.0+np.exp(-x))

# La entrada debe ser un vector de tamaño (1,3)
# el último debe ser igual a 1 (para representar el sesgo)
def hacia_adelante( Entradas ) : 
	# Realizamos los cálculos en la primera capa
	#      1x3      3x2 = 1x2   
	Z1 = Entradas @ P1 

	A1[0,0:2] = sigmoide( Z1 )
	A1[0,2] = 1.0

	###########################
	#    1x3  3x1  = 1x1
	Z2 = A1 @ P2 
	# A2[0,0:1] = sigmoide( Z2 )
	A2[0,0] = sigmoide( Z2 )

	return A2[0,0]

def calcula_deltas( tk ) :
	# A la salida :
	Delta2[0,0] = sigmoide(Z2[0,0])*(1 - sigmoide(Z2[0,0]))*(tk - A2[0,0])

	Delta1[0,0] = sigmoide(Z1[0,0])*(1 - sigmoide(Z1[0,0]))*Delta2[0,0]*P2[0,0]
	Delta1[1,0] = sigmoide(Z1[0,1])*(1 - sigmoide(Z1[0,1]))*Delta2[0,0]*P2[1,0]

def descenso_gradiente( v ) :
	P1[0,0] -= eta * v[0,0] * Delta1[0,0] 
	P1[0,1] -= eta * v[0,0] * Delta1[0,0] 

	P1[1,0] -= eta * v[0,1] * Delta1[1,0] 
	P1[1,1] -= eta * v[0,1] * Delta1[1,0] 

	P1[2,0] -= eta * Delta1[0,0] 
	P1[2,1] -= eta * Delta1[1,0] 

	P2[0,0] -= eta * A1[0,0] * Delta2[0,0] 
	P2[1,0] -= eta * A1[0,1] * Delta2[0,0] 
	P2[2,0] -= eta * Delta2[0,0] 

def calcula_error( ) :
	error = 0.0

	j = 0
	while j < 900 :
		vv[0,:] = [ D[j,0], D[j,1], 1.0 ]
		s = hacia_adelante( vv ) 
		k = s-D[j,2]
		error += k*k
		# print( D[j,0], D[j,1], s )
		j += 1
	
	return np.sqrt(error/900)

# Entrenamiendo

vv = np.zeros( (1,3) )

error = calcula_error( )
print( 0, error )

print( P1 )
print( P2 )

i= 1
while i<20 :

	j = 0
	while j < 900 :
		vv[0,:] = [ D[j,0], D[j,1], 1.0 ]
		s = hacia_adelante( vv ) 
		calcula_deltas( 0 )
		descenso_gradiente( vv )
		j += 1
	
	error = calcula_error( )
	print( i, error )
	i += 1

print( P1 )
print( P2 )
